Imports System.Xml
Imports System.Text
Imports TsChanManLibrary


Public Class frmChannel

    'Public w_sChanPic As String
    'Public w_sChanPicFull As String

    'Dim w_uSet As New clsSettings

    ''' <summary>
    ''' Das Hauptfenster holt sich den Kanal zum Hinzufgen hierber
    ''' </summary>
    ''' <remarks></remarks>
    Public cn As ChannelBase

    ''' <summary>
    ''' Create a new channel
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()
    End Sub

    ''' <summary>
    ''' Edit a selected channel
    ''' </summary>
    ''' <param name="_channel">channel to be edited</param>
    ''' <remarks></remarks>
    Public Sub New(ByVal _channel As ChannelBase)

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        cn = _channel
    End Sub

    ' Button, um neuen Sender zu erstellen (Add Channel)
    Private Sub btnAddChannel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddChannel.Click

        ' Eingabedaten/Vollstndigkeit prfen
        If Feldergefuellt() Then

            ' Kanal im Objekt "cn" erstellen
            CreateChannelbase()

            'MsgBox("The channel has been successfully added", MsgBoxStyle.Information)
            Me.DialogResult = Windows.Forms.DialogResult.OK
        End If
    End Sub

    Private Sub NewChannel_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        ' Ersten Eintrag in der Mode-List fest vorblenden
        cbMode.SelectedIndex = 0

        ' Favoriten-Texte setzen
        rbFav1.Text = cSettings.Cfg.sFavName1
        rbFav2.Text = cSettings.Cfg.sFavName2
        rbFav3.Text = cSettings.Cfg.sFavName3
        rbFav4.Text = cSettings.Cfg.sFavName4
        rbFav5.Text = cSettings.Cfg.sFavName5

        ' Felder an die ausgewhlte Hardware anpassen
        SetWindowAsHardware()

        ' Fr die Nachbearbeitung eines vorhandenen Kanals
        If Not cn Is Nothing Then
            ChannelVorblenden()
        End If
    End Sub

    ' Abbrechen-Button
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Me.DialogResult = Windows.Forms.DialogResult.Cancel
    End Sub

    ''' <summary>
    ''' Checks user input (if all textboxes are filled)
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Function Feldergefuellt() As Boolean

        Dim bReturn As Boolean = True

        If String.IsNullOrEmpty(df_Name.Text) Then
            ErrorProviderNC.SetError(df_Name, "Please enter a name for your channel")
            bReturn = False
        Else
            ErrorProviderNC.SetError(df_Name, "")
        End If

        If String.IsNullOrEmpty(df_Freq.Text) Then
            ErrorProviderNC.SetError(df_Freq, "Please enter a frequency")
            bReturn = False
        Else
            ErrorProviderNC.SetError(df_Freq, "")
        End If

        If df_Symb.Visible Then
            If String.IsNullOrEmpty(df_Symb.Text) Then
                ErrorProviderNC.SetError(df_Symb, "Please enter a Symbolrate")
                bReturn = False
            Else
                ErrorProviderNC.SetError(df_Symb, "")
            End If
        End If

        If String.IsNullOrEmpty(df_ProgNo.Text) Then
            ErrorProviderNC.SetError(df_ProgNo, "Please enter a Program number")
            bReturn = False
        Else
            ErrorProviderNC.SetError(df_ProgNo, "")
        End If

        If PanelDVBS.Visible Then
            If String.IsNullOrEmpty(df_LNBFreq.Text) Then
                ErrorProviderNC.SetError(df_LNBFreq, "Please enter a LNB frequency")
                bReturn = False
            Else
                ErrorProviderNC.SetError(df_LNBFreq, "")
            End If
        End If


        ' Werte prfen (String to Int, etc...)
        If bReturn Then
            If Not Integer.TryParse(df_Freq.Text, Nothing) Then
                ErrorProviderNC.SetError(df_Freq, "Please check the entered frequency - may be it's not a number or the number is too high")
                bReturn = False
            Else
                ErrorProviderNC.SetError(df_Freq, "")
            End If

            If df_Symb.Visible Then
                If Not Integer.TryParse(df_Symb.Text, Nothing) Then
                    ErrorProviderNC.SetError(df_Symb, "Please check the Symbolrate - may be it's not a number or the number is too high")
                    bReturn = False
                Else
                    ErrorProviderNC.SetError(df_Symb, "")
                End If
            End If

            If Not Integer.TryParse(df_ProgNo.Text, Nothing) Then
                ErrorProviderNC.SetError(df_ProgNo, "Please check the program number - may be it's not a number or the number is too high")
                bReturn = False
            Else
                ErrorProviderNC.SetError(df_ProgNo, "")
            End If

            If PanelDVBS.Visible Then
                If Not Integer.TryParse(df_LNBFreq.Text, Nothing) Then
                    ErrorProviderNC.SetError(df_LNBFreq, "Please check the LNB frequency - may be it's not a number or the number is too high")
                    bReturn = False
                Else
                    ErrorProviderNC.SetError(df_LNBFreq, "")
                End If
            End If
        End If



        If bReturn = False Then
            MsgBox("Please correct all errors" & vbCrLf & vbCrLf & _
                   "You can get an error description by hovering your mouse over one of the red icons", _
                   MsgBoxStyle.Information, "Cannot continue")
        End If

        Return bReturn
    End Function

    ' Button zum Suchen eines Kanal-Logo's (100%)
    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pb_Browse.Click

        Using openFileDialog1 As New OpenFileDialog()

            openFileDialog1.Filter = "JPEG (*.jpg)|*.jpg|Bitmap (*.bmp)|*.bmp|Portable Network Graphics (*.png)|*.png|All files (*.*)|*.*"
            openFileDialog1.FilterIndex = 1
            openFileDialog1.RestoreDirectory = True

            If openFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
                Dim bmp As Bitmap
                Try
                    bmp = New Bitmap(openFileDialog1.FileName)
                Catch ex As Exception
                    MsgBox("Could not use the selected picture, please make sure it's a valid Bitmap", MsgBoxStyle.Information, "Picture not valid")
                    Return ' Letztes Logo bleibt erhalten
                End Try

                pic_Logo.Image = bmp
            End If
        End Using
    End Sub

    ' Setzt Die Einstellungen des Form-Windows, je nachdem wie die TV-Hardware gewhlt wurde (100%)
    Sub SetWindowAsHardware()

        ' Wenn DVB-S verwendet wird, Felder deaktivieren
        If cSettings.Cfg.cTvHardware = ChannelType.DVBS Or cSettings.Cfg.cTvHardware = ChannelType.DVBSFull Then

            PanelQAMSwitch.Visible = True
            lblSymbolRate.Visible = True
            df_Symb.Visible = True

            If cSettings.Cfg.cTvHardware = ChannelType.DVBSFull Then
                PanelDVBSFull.Visible = True
            End If

            PanelDVBS.Visible = True

            rb_Switch1.Text = "No"
            rb_Switch2.Text = "TB-A"
            rb_Switch3.Text = "TB-B"
            rb_Switch4.Visible = False
            rb_Switch5.Text = "D1"
            rb_Switch6.Text = "D2"
            rb_Switch7.Text = "D3"
            rb_Switch8.Text = "D4"

            ' DVB-s Einstellungen automatisch setzen
            If cSettings.Cfg.bAutoDVBs Then
                rb_No.Enabled = False
                rb_Yes.Enabled = False
                df_LNBFreq.Enabled = False
                df_LNBFreq.Text = "9750"
                rb_No.Checked = True
            End If

        ElseIf cSettings.Cfg.cTvHardware = ChannelType.DVBC Then

            lblSwitchQAM.Text = "QAM"

            PanelQAMSwitch.Visible = True
            PanelDVBCnT.Visible = True
            lblSymbolRate.Visible = True

            df_Symb.Visible = True
            rb_Switch1.Text = "-16"
            rb_Switch2.Text = "-32"
            rb_Switch3.Text = "-64"
            rb_Switch4.Text = "-128"
            rb_Switch5.Text = "-256"
            rb_Switch6.Visible = False
            rb_Switch7.Visible = False
            rb_Switch8.Visible = False

        ElseIf cSettings.Cfg.cTvHardware = ChannelType.DVBT Then

            PanelDVBCnT.Visible = True
        End If
    End Sub

    ' Die automatische Vergabe von DVB-s Frequenzen regeln
    Private Sub df_Freq_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles df_Freq.TextChanged

        ' Automatische Vergabe von Low- und Highband?
        If cSettings.Cfg.bAutoDVBs And (cSettings.Cfg.cTvHardware = ChannelType.DVBS Or cSettings.Cfg.cTvHardware = ChannelType.DVBSFull) Then
            ' String in Int konvertieren (wenn's geht)
            Dim i As Integer = 0
            Try
                i = df_Freq.Text

                ' ber 11800 liegt das Highband,
                ' drunter das LowBand
                If i > 11800 Then
                    rb_Yes.Checked = True
                    df_LNBFreq.Text = "10600"
                Else
                    rb_No.Checked = True
                    df_LNBFreq.Text = "9750"
                End If
            Catch ex As Exception
                ' Fehler sind egal
            End Try
        End If

    End Sub

    ''' <summary>
    ''' Wenn ein neuer DVB-S Full Mode ausgewhlt wird
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub cbMode_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbMode.SelectedIndexChanged

        ' Alle FEC's entfernen
        cbFEC.Items.Clear()

        ' Je nach Index die verfgbaren FEC's fllen
        If cbMode.SelectedIndex = 0 Then
            cbFEC.Items.Add("1/2")
            cbFEC.Items.Add("2/3")
            cbFEC.Items.Add("3/4")
            cbFEC.Items.Add("5/6")
            cbFEC.Items.Add("7/8")
            cbFEC.Items.Add("Auto")

        ElseIf cbMode.SelectedIndex = 1 Then
            cbFEC.Items.Add("1/4")
            cbFEC.Items.Add("1/2")
            cbFEC.Items.Add("3/4")

        ElseIf cbMode.SelectedIndex = 2 Then
            cbFEC.Items.Add("2/3")
            cbFEC.Items.Add("3/4 I")
            cbFEC.Items.Add("3/4 II")
            cbFEC.Items.Add("5/6")
            cbFEC.Items.Add("8/9")

        ElseIf cbMode.SelectedIndex = 3 Then
            cbFEC.Items.Add("3/4")

        ElseIf cbMode.SelectedIndex > 3 And cbMode.SelectedIndex < 8 Then
            cbFEC.Items.Add("5/11")
            cbFEC.Items.Add("1/2")
            cbFEC.Items.Add("3/5")
            cbFEC.Items.Add("2/3")
            cbFEC.Items.Add("3/4")
            cbFEC.Items.Add("4/5")
            cbFEC.Items.Add("5/6")
            cbFEC.Items.Add("7/8")
            cbFEC.Items.Add("Auto")

        ElseIf cbMode.SelectedIndex = 8 Then
            cbFEC.Items.Add("1/2")
            cbFEC.Items.Add("2/3")
            cbFEC.Items.Add("3/5")
            cbFEC.Items.Add("3/4")
            cbFEC.Items.Add("4/5")
            cbFEC.Items.Add("5/6")
            cbFEC.Items.Add("7/8")
            cbFEC.Items.Add("8/9")
            cbFEC.Items.Add("9/10")
            cbFEC.Items.Add("Auto")

        End If

        ' Den ersten FEC-Eintrag auswhlen
        cbFEC.SelectedIndex = 0
    End Sub

    Private Sub CreateChannelbase()

        ' Favoritengruppe setzen
        Dim iFav As Integer = 0
        If rbFav1.Checked Then
            iFav = 1
        ElseIf rbFav2.Checked Then
            iFav = 2
        ElseIf rbFav3.Checked Then
            iFav = 3
        ElseIf rbFav4.Checked Then
            iFav = 4
        ElseIf rbFav5.Checked Then
            iFav = 5
        End If

        Dim Pol As DvbSPols = DvbSPols.Vertical
        If rb_Ho.Checked Then
            Pol = DvbSPols.Horizontal
        End If

        Dim iSwitch As Short = 0, iQAM As Short = 0
        If rb_Switch2.Checked Then
            iSwitch = 5
            iQAM = 1
        ElseIf rb_Switch3.Checked Then
            iSwitch = 6
            iQAM = 2
        ElseIf rb_Switch4.Checked Then
            iQAM = 3
        ElseIf rb_Switch5.Checked Then
            iSwitch = 1
            iQAM = 4
        ElseIf rb_Switch6.Checked Then
            iSwitch = 2
        ElseIf rb_Switch7.Checked Then
            iSwitch = 3
        ElseIf rb_Switch8.Checked Then
            iSwitch = 4
        End If

        Dim iBandWith As Short = 0
        If rb_Band7.Checked Then
            iBandWith = 1
        ElseIf rb_Band8.Checked Then
            iBandWith = 2
        End If

        If cSettings.Cfg.cTvHardware = ChannelType.DVBS Then
            cn = New ChannelDVBS(df_Name.Text, Integer.Parse(df_Freq.Text), iFav, _
                                    Integer.Parse(df_ProgNo.Text), pic_Logo.Image, _
                                    Integer.Parse(df_Symb.Text), Integer.Parse(df_LNBFreq.Text), _
                                    rb_Yes.Checked, Pol, iSwitch)
        ElseIf cSettings.Cfg.cTvHardware = ChannelType.DVBSFull Then
            cn = New ChannelDVBSFull(df_Name.Text, Integer.Parse(df_Freq.Text), iFav, _
                                    Integer.Parse(df_ProgNo.Text), pic_Logo.Image, _
                                    Integer.Parse(df_Symb.Text), Integer.Parse(df_LNBFreq.Text), _
                                    rb_Yes.Checked, Pol, iSwitch, cbMode.SelectedIndex, cbFEC.SelectedIndex)
        ElseIf cSettings.Cfg.cTvHardware = ChannelType.DVBC Then
            cn = New ChannelDVBC(df_Name.Text, Integer.Parse(df_Freq.Text), iFav, _
                                    Integer.Parse(df_ProgNo.Text), pic_Logo.Image, _
                                    Integer.Parse(df_Symb.Text), iQAM, rb_Inversion1.Checked, _
                                    iBandWith)
        ElseIf cSettings.Cfg.cTvHardware = ChannelType.DVBT Then
            cn = New ChannelDVBT(df_Name.Text, Integer.Parse(df_Freq.Text), iFav, _
                                    Integer.Parse(df_ProgNo.Text), pic_Logo.Image, _
                                    rb_Inversion1.Checked, iBandWith)
        Else
            cn = New ChannelBase(df_Name.Text, Integer.Parse(df_Freq.Text), iFav, _
                                    Integer.Parse(df_ProgNo.Text), pic_Logo.Image)
        End If
    End Sub

    ''' <summary>
    ''' Blendet alle Kanal-Details fr die Nachbearbeitung eines vorhanden Kanals ein
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub ChannelVorblenden()

        df_Name.Text = cn.sName
        pic_Logo.Image = cn.bLogo
        df_Freq.Text = cn.iFrequency
        df_ProgNo.Text = cn.iProgNo

        If cn.iFavorite = 1 Then
            rbFav1.Checked = True
        ElseIf cn.iFavorite = 2 Then
            rbFav2.Checked = True
        ElseIf cn.iFavorite = 3 Then
            rbFav3.Checked = True
        ElseIf cn.iFavorite = 4 Then
            rbFav4.Checked = True
        ElseIf cn.iFavorite = 5 Then
            rbFav5.Checked = True
        End If

        ' Hardware specific settings
        If cn.GetType() Is GetType(ChannelDVBS) Or cn.GetType() Is GetType(ChannelDVBSFull) Then

            Dim cdummy As ChannelDVBS = cn
            df_Symb.Text = cdummy.iSymbolRate
            df_LNBFreq.Text = cdummy.iLNBFrequency
            If Not cdummy.bKhz Then rb_No.Checked = True
            If cdummy.polarisation = DvbSPols.Vertical Then rb_Ve.Checked = True

            If cdummy.shSwitch = 1 Then
                rb_Switch5.Checked = True
            ElseIf cdummy.shSwitch = 2 Then
                rb_Switch6.Checked = True
            ElseIf cdummy.shSwitch = 3 Then
                rb_Switch7.Checked = True
            ElseIf cdummy.shSwitch = 4 Then
                rb_Switch8.Checked = True
            ElseIf cdummy.shSwitch = 5 Then
                rb_Switch2.Checked = True
            ElseIf cdummy.shSwitch = 6 Then
                rb_Switch3.Checked = True
            End If

            If cn.GetType() Is GetType(ChannelDVBSFull) Then
                Dim cdummy2 As ChannelDVBSFull = cdummy
                cbMode.SelectedIndex = cdummy2.dvbsMode
                cbFEC.SelectedIndex = cdummy2.iFec
            End If
        ElseIf cn.GetType() Is GetType(ChannelDVBC) Then

            Dim cdummy As ChannelDVBC = cn
            df_Symb.Text = cdummy.iSymbolRate
            If cdummy.bInversion Then rb_Inversion1.Checked = True

            If cdummy.iBandwith = 1 Then
                rb_Band7.Checked = True
            ElseIf cdummy.iBandwith = 2 Then
                rb_Band8.Checked = True
            End If

            If cdummy.iQAM = 1 Then
                rb_Switch2.Checked = True
            ElseIf cdummy.iQAM = 2 Then
                rb_Switch3.Checked = True
            ElseIf cdummy.iQAM = 3 Then
                rb_Switch4.Checked = True
            ElseIf cdummy.iQAM = 4 Then
                rb_Switch5.Checked = True
            End If

        ElseIf cn.GetType() Is GetType(ChannelDVBT) Then
            Dim cdummy As ChannelDVBT = cn
            If cdummy.bInversion Then rb_Inversion1.Checked = True

            If cdummy.iBandwith = 1 Then
                rb_Band7.Checked = True
            ElseIf cdummy.iBandwith = 2 Then
                rb_Band8.Checked = True
            End If
        End If

        btnAddChannel.Text = "Update channel"
        Me.Text = "Edit channel"
    End Sub

    Private Sub btnResetLogo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnResetLogo.Click
        pic_Logo.Image = Nothing
    End Sub
End Class