Imports System.IO
Imports TsChanManLibrary
Imports System.Net

Public Class frmSettings

    ' Beim Laden des Form-Windows (100%)
    Private Sub frmSettings_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        ' TSReader & VLC Media Player Exe Files
        df_TSFile.Text = cSettings.Cfg.sTsReaderExe
        tbVlcExe.Text = cSettings.Cfg.sVlcExe

        tbServerAddress.Text = cSettings.Cfg.sServerIP

        ' If NullOrEmpty dann Standard Server Command vorgeblendet
        If String.IsNullOrEmpty(cSettings.Cfg.sVlcServerCommand) Then
            cbDefaultVlcServerCommand.Checked = True
        ElseIf cSettings.Cfg.sVlcServerCommand <> cSettings.sVlcDefaultCommand Then
            tbVlcServerCommand.Text = cSettings.Cfg.sVlcServerCommand
            cbDefaultVlcServerCommand.Checked = False
        End If

        If cSettings.Cfg.iServerPort = 0 Then ' Standard fr die Int32 Initialisierung
            cbUseDefPort.Checked = True
        ElseIf cSettings.Cfg.iServerPort <> cSettings.iDefaultPort Then
            tbPort.Text = cSettings.Cfg.iServerPort
            cbUseDefPort.Checked = False
        End If

        ' CheckForEXEFiles() might override this setting (Only at first start)
        cbInternalVlcPlayer.Checked = cSettings.Cfg.bInternalVlcPlayer

        If String.IsNullOrEmpty(cSettings.Cfg.sTsReaderExe) Or _
                String.IsNullOrEmpty(cSettings.Cfg.sVlcExe) Then CheckForEXEFiles()

        ' Checkbox fr 'TSReader minimiert starten'
        cb_minimized.Checked = cSettings.Cfg.bStartTSReaderMinimized

        ' Checkbox fr 'TSReader in der Notification Area minimiert starten'
        cb_minimizedNotCfgArea.Checked = cSettings.Cfg.bStartTSReaderMinimizedToNtfcArea

        ' Checkbox fr 'nur eine Instanz des TSReaders ausfhren'
        cb_Single.Checked = cSettings.Cfg.bSingleTSReaderInstance

        ' Checkbox fr 'im Uni-Prozessor-Modus laufen lassen'
        cb_Processor.Checked = cSettings.Cfg.bUniProcessorTSReader

        ' Checkbox fr's parsing
        cb_Parsing.Checked = cSettings.Cfg.bDisableTSReaderThumbnailStreamParsing

        cb_Hardware.DataSource = [Enum].GetNames(GetType(ChannelType))
        cb_Hardware.Text = [Enum].GetName(GetType(ChannelType), cSettings.Cfg.cTvHardware)

        ' AutoDVBs-Setting
        cb_AutmaticDVBSetting.Checked = cSettings.Cfg.bAutoDVBs

        ' Favoriten-Texte setzen
        If Not String.IsNullOrEmpty(cSettings.Cfg.sFavName1) Then tb_FavGroup1.Text = cSettings.Cfg.sFavName1
        If Not String.IsNullOrEmpty(cSettings.Cfg.sFavName2) Then tb_FavGroup2.Text = cSettings.Cfg.sFavName2
        If Not String.IsNullOrEmpty(cSettings.Cfg.sFavName3) Then tb_FavGroup3.Text = cSettings.Cfg.sFavName3
        If Not String.IsNullOrEmpty(cSettings.Cfg.sFavName4) Then tb_FavGroup4.Text = cSettings.Cfg.sFavName4
        If Not String.IsNullOrEmpty(cSettings.Cfg.sFavName5) Then tb_FavGroup5.Text = cSettings.Cfg.sFavName5

        ' Make sure "cb_AutmaticDVBSetting" is only enabled if "DVB-S"
        cb_Hardware_SelectedIndexChanged(Nothing, Nothing)
    End Sub

    ' Abbrechen-Button (100%)
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click

        ' frmSettings schlieen
        Me.DialogResult = Windows.Forms.DialogResult.Cancel
    End Sub

    ' Durchsuchen-Button (100%)
    Private Sub pb_TSExe_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pb_TSExe.Click

        ' OpenFileDialog deklarieren
        Dim openFileDialog1 As New OpenFileDialog()

        ' Parameter fr den OpenFileDialog festlegen
        openFileDialog1.InitialDirectory = "C:\"
        openFileDialog1.Filter = "TSReader Executable (*.exe)|*.exe|All files (*.*)|*.*"
        openFileDialog1.FilterIndex = 1
        openFileDialog1.RestoreDirectory = True

        ' Dateiname in Textbox schreiben
        If openFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
            df_TSFile.Text = openFileDialog1.FileName
        End If

    End Sub



    ' Einstellungen bernehmen (100%)
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pb_OK.Click

        'If Not Me.Validate() Then Return

        cSettings.Cfg.sVlcExe = tbVlcExe.Text
        cSettings.Cfg.sTsReaderExe = df_TSFile.Text
        If Not Integer.TryParse(tbPort.Text, cSettings.Cfg.iServerPort) Then
            MsgBox(String.Format("Port {0} invalid{1}Only numbers are supported", tbPort.Text, vbCrLf), MsgBoxStyle.Exclamation)
            Return
        End If

        If Not String.IsNullOrEmpty(tbServerAddress.Text) AndAlso _
        Not IPAddress.TryParse(tbServerAddress.Text, New IPAddress(2)) Then
            MsgBox(String.Format("IP address {0} invalid{1}Please check the format", tbServerAddress.Text, vbCrLf), MsgBoxStyle.Exclamation)
            Return
        Else
            cSettings.Cfg.sServerIP = tbServerAddress.Text
        End If
        cSettings.Cfg.sVlcServerCommand = tbVlcServerCommand.Text
        cSettings.Cfg.bStartTSReaderMinimizedToNtfcArea = cb_minimizedNotCfgArea.Checked
        cSettings.Cfg.bDisableTSReaderThumbnailStreamParsing = cb_Parsing.Checked
        cSettings.Cfg.bSingleTSReaderInstance = cb_Single.Checked
        cSettings.Cfg.bStartTSReaderMinimized = cb_minimized.Checked
        cSettings.Cfg.bUniProcessorTSReader = cb_Processor.Checked
        cSettings.Cfg.cTvHardware = [Enum].Parse(GetType(ChannelType), cb_Hardware.Text)
        cSettings.Cfg.bAutoDVBs = cb_AutmaticDVBSetting.Checked
        cSettings.Cfg.bInternalVlcPlayer = cbInternalVlcPlayer.Checked
        cSettings.Cfg.sFavName1 = tb_FavGroup1.Text
        cSettings.Cfg.sFavName2 = tb_FavGroup2.Text
        cSettings.Cfg.sFavName3 = tb_FavGroup3.Text
        cSettings.Cfg.sFavName4 = tb_FavGroup4.Text
        cSettings.Cfg.sFavName5 = tb_FavGroup5.Text

        cSettings.SaveCfg()

        ' Fenster schlieen
        Me.DialogResult = Windows.Forms.DialogResult.OK
    End Sub

    ' TV-Hardware gendert (100%)
    Private Sub cb_Hardware_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cb_Hardware.SelectedIndexChanged

        ' Checkbox fr automatische einstellung des Low- und Highband
        If CType([Enum].Parse(GetType(ChannelType), cb_Hardware.Text), ChannelType) = ChannelType.DVBS Or _
            CType([Enum].Parse(GetType(ChannelType), cb_Hardware.Text), ChannelType) = ChannelType.DVBSFull Then
            cb_AutmaticDVBSetting.Enabled = True
        Else
            cb_AutmaticDVBSetting.Enabled = False
        End If
    End Sub

    Private Sub cbUseDefPort_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbUseDefPort.CheckedChanged

        If cbUseDefPort.Checked Then ' Standardport ohne Benutzereingabe
            tbPort.Text = cSettings.iDefaultPort
            tbPort.Enabled = False
        Else ' Benutzerdefiniert
            tbPort.Enabled = True
        End If
    End Sub

    Private Sub btnBrowseVlcExe_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBrowseVlcExe.Click
        Using opFDiag As New OpenFileDialog()

            ' Parameter fr den OpenFileDialog festlegen
            opFDiag.InitialDirectory = "C:\"
            opFDiag.Filter = "VideoLAN Executable (*.exe)|*.exe|All files (*.*)|*.*"
            opFDiag.FilterIndex = 1
            opFDiag.RestoreDirectory = True

            ' Dateiname in Textbox schreiben
            If opFDiag.ShowDialog() = Windows.Forms.DialogResult.OK Then
                tbVlcExe.Text = opFDiag.FileName
            End If
        End Using
    End Sub

    Private Sub CheckForEXEFiles()

        Dim strMessage As String = "The TSReader Channel Manager has automatically detected the following Executables:" & vbCrLf & vbCrLf
        Dim bDetectedFile As Boolean = False ' True sobald eine Exe-Datei entdeckt wurde

        Dim strVLC As String = Path.Combine(My.Computer.FileSystem.SpecialDirectories.ProgramFiles, "VideoLAN\VLC\vlc.exe")
        Dim strTSReader As String = Path.Combine(My.Computer.FileSystem.SpecialDirectories.ProgramFiles, "COOL.STF\TSReader\TSReader.exe")
        Dim strTSReaderLight As String = Path.Combine(My.Computer.FileSystem.SpecialDirectories.ProgramFiles, "COOL.STF\TSReader Light\TSReader.exe")

        ' Den VideoLAN Media Player suchen
        If File.Exists(strVLC) And String.IsNullOrEmpty(cSettings.Cfg.sVlcExe) Then
            bDetectedFile = True
            strMessage += strVLC & vbCrLf
            tbVlcExe.Text = strVLC
            cbInternalVlcPlayer.Checked = True
        End If

        ' TSReader suchen
        If File.Exists(strTSReader) And String.IsNullOrEmpty(cSettings.Cfg.sTsReaderExe) Then
            bDetectedFile = True
            strMessage += strTSReader & vbCrLf
            df_TSFile.Text = strTSReader
        ElseIf File.Exists(strTSReaderLight) And String.IsNullOrEmpty(cSettings.Cfg.sTsReaderExe) Then
            'TODO
        End If

        If bDetectedFile Then
            strMessage += vbCrLf & "Please check if the filenames are correct"
            MsgBox(strMessage, MsgBoxStyle.Information)
        End If
    End Sub

    Private Sub cbDefaultVlcServerCommand_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbDefaultVlcServerCommand.CheckedChanged, cbInternalVlcPlayer.CheckedChanged
        If cbDefaultVlcServerCommand.Checked Then ' Default Server Command ohne Benutzereingabe
            tbVlcServerCommand.Text = cSettings.sVlcDefaultCommand
            tbVlcServerCommand.Enabled = False
        Else ' Benutzerdefiniert
            tbVlcServerCommand.Enabled = True
        End If
    End Sub

#Region "Checkbox-Zusammenspiel zwischen 'minimiert starten' & 'minimiert in Notification Area starten'"
    Private Sub cb_minimized_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cb_minimized.CheckedChanged
        If cb_minimized.Checked Then
            cb_minimizedNotCfgArea.Checked = False
            cb_minimizedNotCfgArea.Enabled = False
        Else
            cb_minimizedNotCfgArea.Enabled = True
        End If
    End Sub
    Private Sub cb_minimizedNotCfgArea_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cb_minimizedNotCfgArea.CheckedChanged
        If cb_minimizedNotCfgArea.Checked Then
            cb_minimized.Checked = False
            cb_minimized.Enabled = False
        Else
            cb_minimized.Enabled = True
        End If
    End Sub
#End Region

    Private Sub tbVlcServerCommand_Validating(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles tbVlcServerCommand.Validating

        If tbVlcServerCommand.Text.IndexOf("{0}") = -1 Then
            ErrorProviderCFG.SetError(tbVlcServerCommand, "Please make sure you include '{0}', so this can be replaced with the server IP address")
            e.Cancel = True
        End If
    End Sub
End Class