Imports TsChanManLibrary

Public Class frm_MainWindow

    Private chanMngmnt As cChannels
    Private StatusMessage As String = String.Empty
    Private CopiedChannel As ChannelBase = Nothing

    Private Sub frm_MainWindow_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Try


            If Not cSettings.LoadCfg() Then
                MsgBox("Obviously this is the first time you start TSReader Channel Manager." & vbCrLf & _
                       "Before you're able to use this application you have to configure it." & vbCrLf & vbCrLf & _
                       "To launch the configuration dialog, click OK", MsgBoxStyle.Information)
                Dim frm As New frmSettings
                If frm.ShowDialog() = Windows.Forms.DialogResult.Cancel Then
                    Application.Exit()
                    Return
                End If
            End If
        Catch ex As System.TypeInitializationException ' In case a user starts it from a network location
            MsgBox("The application cannot be started. " & vbCrLf & _
                   "Please make sure you installed the application on your local computer.")
            Application.ExitThread()
            Return
        End Try

        chanMngmnt = New cChannels(cSettings.Cfg.cTvHardware)

        ' Beschreibungen fr VLC aus der Registry holen & Events hierfr setzen
        VLC_Commands()

        ' Setzt die Namen der Favoriten-Gruppen, Fgt Handler hinzu und zeigt nur
        ' die Favortitengruppe an, die beim letzen Programmablauf gewhlt wurde
        LF_FavoriteNames()

        ' berschriften fr die Detailansicht im Listview setzen
        SetColumnHeader()

        ' Kanle anzeigen
        DisplayChannels()

        'Command Line Parameter auswerten -- ber /StartServer direkt Server starten
        Dim bServerAutoStart As Boolean = False
        For Each cmdArg As String In Environment.GetCommandLineArgs()
            If cmdArg.IndexOf("/StartServer") >= 0 Then bServerAutoStart = True
        Next

        If bServerAutoStart Then
            StartServerToolStripMenuItem_Click(Nothing, Nothing)
        Else
            StopServerToolStripMenuItem.Enabled = False
        End If
    End Sub

    Private Sub lsv_ChannelList_DoubleClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lsv_ChannelList.DoubleClick
        If lsv_ChannelList.SelectedItems.Count > 0 Then chanMngmnt.LaunchFrequency(lsv_ChannelList.SelectedItems(0).Tag)
    End Sub

    ' In TSReader Lite starten
    Private Sub tsmi_RuninLite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmi_RuninLite.Click

        If lsv_ChannelList.SelectedItems.Count > 0 Then

            Dim channel As ChannelBase = lsv_ChannelList.SelectedItems(0).Tag

            If cSettings.Cfg.cTvHardware = ChannelType.DVBS Then
                Dim channelS As ChannelDVBS = channel
                My.Computer.Registry.SetValue("HKEY_CURRENT_USER\SOFTWARE\COOL.STF\TSReader", "Last22KHz", Convert.ToInt32(channelS.bKhz), Microsoft.Win32.RegistryValueKind.DWord)
                My.Computer.Registry.SetValue("HKEY_CURRENT_USER\SOFTWARE\COOL.STF\TSReader", "LastDiSEqCInput", channelS.shSwitch, Microsoft.Win32.RegistryValueKind.DWord)
                My.Computer.Registry.SetValue("HKEY_CURRENT_USER\SOFTWARE\COOL.STF\TSReader", "LastFrequency", channelS.iFrequency, Microsoft.Win32.RegistryValueKind.DWord)
                My.Computer.Registry.SetValue("HKEY_CURRENT_USER\SOFTWARE\COOL.STF\TSReader", "LastPolarity", Convert.ToInt32(channelS.polarisation), Microsoft.Win32.RegistryValueKind.DWord)
                My.Computer.Registry.SetValue("HKEY_CURRENT_USER\SOFTWARE\COOL.STF\TSReader", "LASTLNBFrequency", channelS.iLNBFrequency, Microsoft.Win32.RegistryValueKind.DWord)
                My.Computer.Registry.SetValue("HKEY_CURRENT_USER\SOFTWARE\COOL.STF\TSReader", "LastSymbolRate", channelS.iSymbolRate, Microsoft.Win32.RegistryValueKind.DWord)

            Else
                MsgBox("This feature is currently only usable in DVB-S mode")
            End If

            ' TSReader Lite starten
            Dim programId As Integer = Shell(cSettings.Cfg.sTsReaderExe, AppWinStyle.NormalFocus)

            Try
                ' Programm in den Vordergrund bringen
                AppActivate(programId)

            Catch ex As Exception

            End Try

            ' Enter senden
            My.Computer.Keyboard.SendKeys("{ENTER}", True)
        End If
    End Sub

    Private Sub tsb_About_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsb_About.Click
        AboutBox.ShowDialog()
    End Sub

    Private Sub tsmi_Edit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmi_Edit.Click

        If lsv_ChannelList.SelectedItems.Count > 0 Then

            Dim lviChannel As ListViewItem = lsv_ChannelList.SelectedItems(0)
            Dim channel As ChannelBase = lviChannel.Tag

            ' Um den Kanal in der List spter an dieser Stelle berschreiben zu knnen
            Dim iChannel As Integer = chanMngmnt.currChannels.IndexOf(channel)

            Dim frm As New frmChannel(channel) ' Mit Kanal im Konstruktor == Bearbeitungsmodus
            If frm.ShowDialog() = Windows.Forms.DialogResult.OK Then

                chanMngmnt.ReplaceChannel(iChannel, frm.cn)

                DisplayChannels()

                ' Re-select channel user just edited
                lsv_ChannelList.FindItemWithText(frm.cn.sName).Selected = True
            End If
        End If
    End Sub

    ''' <summary>
    ''' Record channel
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub tsmi_Record_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmi_Record.Click
        If lsv_ChannelList.SelectedItems.Count = 1 Then
            Dim cn As ChannelBase = lsv_ChannelList.SelectedItems(0).Tag
            Dim frm As New frmRecord(cn)

            If frm.ShowDialog() = Windows.Forms.DialogResult.OK Then chanMngmnt.RecordChannel(cn, frm.rConfig)
        End If
    End Sub

    Private Sub tsb_Refresh_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsb_Refresh.Click
        DisplayChannels()
    End Sub

#Region "Ansicht der Kanalliste (Details, Liste, Icons, ...)"
    Private Sub tsmi_List_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmi_List.Click
        lsv_ChannelList.View = View.List
    End Sub
    Private Sub tsmi_Icons_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmi_Icons.Click
        lsv_ChannelList.View = View.LargeIcon
    End Sub
    Private Sub tsmi_Details_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmi_Details.Click
        lsv_ChannelList.View = View.Details
    End Sub
#End Region

    ' TSReader-XML-File Import
    ' TODO
    Private Sub tsb_Import_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsb_Import.Click
        mdiXMLImport.ShowDialog()
    End Sub

    Private Sub tsmi_Delete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmi_Delete.Click

        If lsv_ChannelList.SelectedItems.Count > 0 Then

            Dim channel As ChannelBase = lsv_ChannelList.SelectedItems(0).Tag

            ' Sicherheitsabfrage, um versehentliches Lschen auszuschlieen
            If MsgBox("Are you sure to delete " & lsv_ChannelList.SelectedItems(0).Text & " ?", MsgBoxStyle.YesNo + MsgBoxStyle.Information, "Delete Channel?") = MsgBoxResult.Yes Then
                chanMngmnt.RemoveChannel(channel)
                DisplayChannels()
            End If
        End If
    End Sub

    ' Spalten-berschriften je nach TV-Typ setzen (100%)
    Sub SetColumnHeader()

        lsv_ChannelList.Columns.Clear()

        lsv_ChannelList.Columns.Add("Channel-Name", 170)
        lsv_ChannelList.Columns.Add("Frequency", 65)

        ' Den Listview je nach Hardware anpassen
        If cSettings.Cfg.cTvHardware = ChannelType.DVBS Then
            lsv_ChannelList.Columns.Add("Symbolrate", 65)
            lsv_ChannelList.Columns.Add("LNB-Frequency", 70)
            lsv_ChannelList.Columns.Add("KhZ", 50)
            lsv_ChannelList.Columns.Add("Polarisation", 80)
            lsv_ChannelList.Columns.Add("Diseqc", 50)

        ElseIf cSettings.Cfg.cTvHardware = ChannelType.DVBSFull Then
            lsv_ChannelList.Columns.Add("Symbolrate", 65)
            lsv_ChannelList.Columns.Add("LNB-Frequency", 70)
            lsv_ChannelList.Columns.Add("KhZ", 50)
            lsv_ChannelList.Columns.Add("Polarisation", 80)
            lsv_ChannelList.Columns.Add("Mode", 80)
            lsv_ChannelList.Columns.Add("Fec", 50)
            lsv_ChannelList.Columns.Add("Diseqc", 50)

        ElseIf cSettings.Cfg.cTvHardware = ChannelType.DVBC Then
            lsv_ChannelList.Columns.Add("Symbolrate", 65)
            lsv_ChannelList.Columns.Add("QAM", 50)
            lsv_ChannelList.Columns.Add("Inversion", 65)
            lsv_ChannelList.Columns.Add("Bandwith", 65)

        ElseIf cSettings.Cfg.cTvHardware = ChannelType.DVBT Then
            lsv_ChannelList.Columns.Add("Inversion", 65)
            lsv_ChannelList.Columns.Add("Bandwith", 65)

        End If

        lsv_ChannelList.Columns.Add("Program-Number", 75)
    End Sub

    Private Sub tsb_Settings_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsb_Settings.Click
        Dim frm As New frmSettings()
        If frm.ShowDialog() = Windows.Forms.DialogResult.OK Then

            ' Kanal-Management auf die evntl. vernderte TV-Hardware anpassen
            chanMngmnt = New cChannels(cSettings.Cfg.cTvHardware)
            LF_FavoriteNames() ' Favoriten neu anpassen (evntl. durch Namensnderung)
            DisplayChannels() ' Kanle neu einlesen
            SetColumnHeader() ' Spalten in der Detailansicht des Listviews anpassen (evntl. durch TV-Hardware nderung)
        End If
    End Sub

    Private Sub tsb_NewChannel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsb_NewChannel.Click
        Dim frm As New frmChannel()
        If frm.ShowDialog() = Windows.Forms.DialogResult.OK Then

            chanMngmnt.AddChannel(frm.cn) ' Kanal hinzufgen
            DisplayChannels() ' Kanle neu einlesen
        End If
    End Sub

    Private Sub tsmi_ExportXML_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmi_ExportXML.Click

        If lsv_ChannelList.SelectedItems.Count = 1 Then

            Dim can As ChannelBase = lsv_ChannelList.SelectedItems(0).Tag

            Dim sfd As New SaveFileDialog()

            sfd.InitialDirectory = "C:\"
            sfd.Filter = "XML-File (*.xml)|*.xml"
            sfd.FilterIndex = 1
            sfd.RestoreDirectory = True

            If sfd.ShowDialog() = Windows.Forms.DialogResult.OK Then
                chanMngmnt.ExportFrequencyFile(FileExportType.XML, sfd.FileName, can)
            End If
        End If
    End Sub

    Private Sub tsmi_ExportHTML_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmi_ExportHTML.Click

        If lsv_ChannelList.SelectedItems.Count = 1 Then

            Dim can As ChannelBase = lsv_ChannelList.SelectedItems(0).Tag

            Dim sfd As New SaveFileDialog()

            sfd.InitialDirectory = "C:\"
            sfd.Filter = "XML-File (*.html)|*.html"
            sfd.FilterIndex = 1
            sfd.RestoreDirectory = True

            If sfd.ShowDialog() = Windows.Forms.DialogResult.OK Then
                chanMngmnt.ExportFrequencyFile(FileExportType.HTML, sfd.FileName, can)
            End If
        End If
    End Sub

    ''' <summary>
    ''' Den Button zur Anzeige der Satelliten-Transponderliste drcken
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub tsddb_TransponderListe_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsddb_TransponderListe.Click

        ' Hardware checken und nur bei DVB-s Dialog ffnen
        If cSettings.Cfg.cTvHardware = ChannelType.DVBS Or cSettings.Cfg.cTvHardware = ChannelType.DVBSFull Then

            ' Wenn die Kanal-Liste als aktuelle Ansicht verwendet wird
            If lsv_ChannelList.Visible Then

                ' Kanal-Liste verstecken
                lsv_ChannelList.Visible = False

                ' Das User-Control der TransponderListe instanzieren
                Dim ucSaTrns As New ucDVBsTransponderList()

                ' Das UserControl komplett in das Panel eindocken
                ucSaTrns.Dock = DockStyle.Fill

                ' Das Control in dieses Fenster einfgen
                PanelMain.Controls.Add(ucSaTrns)

                ' Den Button fr die TransponderListe auswhlen
                tsddb_TransponderListe.Checked = True
            Else

                ' Das User-Control der Transponderliste mit allen Resourcen freigeben
                PanelMain.Controls("ucDVBsTransponderList").Dispose()

                ' Die Kanal-Liste wieder anzeigen
                lsv_ChannelList.Visible = True

                ' Der Button darf nicht mehr angehakt sein
                tsddb_TransponderListe.Checked = False
            End If

        Else
            MsgBox("The transponder-list will only work in DVB-S or DVB-S Full mode")
        End If
    End Sub

#Region "Favoriten-Handling"
    ''' <summary>
    ''' In den Menfeldern die Namen der Favoriten setzen
    ''' </summary>
    ''' <remarks></remarks>
    Sub LF_FavoriteNames()

        ' Um 'Alle Favoriten' auch als Event zu bekommen
        AddHandler tsddb_Favorites.DropDownItems(0).Click, AddressOf tsmi_FavView_Click
        AddHandler tsmi_Favorites.DropDownItems(6).Click, AddressOf tsmi_FavSet_Click


        Dim sValue As String = ""
        For i As Integer = 1 To 5
            If i = 1 Then
                sValue = cSettings.Cfg.sFavName1
            ElseIf i = 2 Then
                sValue = cSettings.Cfg.sFavName2
            ElseIf i = 3 Then
                sValue = cSettings.Cfg.sFavName3
            ElseIf i = 4 Then
                sValue = cSettings.Cfg.sFavName4
            ElseIf i = 5 Then
                sValue = cSettings.Cfg.sFavName5
            End If

            tsmi_Favorites.DropDownItems(i - 1).Text = sValue ' tsmi = In der Kanalliste
            AddHandler tsmi_Favorites.DropDownItems(i - 1).Click, AddressOf tsmi_FavSet_Click

            tsddb_Favorites.DropDownItems(i + 1).Text = sValue ' tsddb = Men oben
            AddHandler tsddb_Favorites.DropDownItems(i + 1).Click, AddressOf tsmi_FavView_Click
        Next

        If cSettings.Cfg.lastFavorite <> 0 Then
            tsmi_FavAuswahlAll.Checked = False ' Standardmig werden alle Sender angezeigt
            Dim ts As ToolStripMenuItem = tsddb_Favorites.DropDownItems(cSettings.Cfg.lastFavorite + 1)
            ts.Checked = True
        End If
    End Sub

    Private Sub tsmi_FavView_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

        ' Alle Favoritengruppen deselektieren
        For Each ts As Object In tsddb_Favorites.DropDownItems
            If TypeOf (ts) Is ToolStripMenuItem Then ts.Checked = False
        Next

        Dim tmu As ToolStripMenuItem = sender

        Dim tmuI As Integer = tsddb_Favorites.DropDownItems.IndexOf(tmu)
        If tmuI > 0 Then tmuI -= 1 ' Dadurch das der Seperator den Index 1 hat (Index 0 == Alle Favoriten)

        tmu.Checked = True

        ' Favoritennummer setzen und Sender entsprechend neu einlesen
        cSettings.Cfg.lastFavorite = tmuI
        DisplayChannels()
    End Sub

    ''' <summary>
    ''' Anzeige, welcher Favoritengruppe welcher Sender zugeteilt ist
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub tsmi_Favorites_MouseHover(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmi_Favorites.MouseHover

        If lsv_ChannelList.SelectedItems.Count > 0 Then

            ' Alle Favoritengruppen deselektieren
            For Each ts As Object In tsmi_Favorites.DropDownItems
                If TypeOf (ts) Is ToolStripMenuItem Then ts.Checked = False
            Next

            Dim cn As ChannelBase = lsv_ChannelList.SelectedItems(0).Tag
            If cn.iFavorite = 0 Then
                tsmi_RemoveFavorite.Checked = True
            Else
                Dim ts As ToolStripMenuItem = tsmi_Favorites.DropDownItems(cn.iFavorite - 1)
                ts.Checked = True
            End If
        End If
    End Sub

    Private Sub tsmi_FavSet_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        If lsv_ChannelList.SelectedItems.Count = 1 Then

            Dim iTs As Integer = tsmi_Favorites.DropDownItems.IndexOf(sender)
            If iTs = 6 Then
                iTs = 0 ' Index 6 reprsentiert 'Not assigned to favorites'
            Else
                iTs += 1
            End If

            Dim cn As ChannelBase = lsv_ChannelList.SelectedItems(0).Tag
            chanMngmnt.ChangeChannelFavorite(iTs, cn)

            If cSettings.Cfg.lastFavorite <> 0 Then DisplayChannels() ' Re-Read current favorite list
        End If
    End Sub
#End Region

    ' Kanal ber Return/Enter starten
    Private Sub lsv_ChannelList_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles lsv_ChannelList.KeyPress
        If Asc(e.KeyChar) = 13 Then
            If lsv_ChannelList.SelectedItems.Count = 1 Then
                lsv_ChannelList_DoubleClick(Nothing, Nothing)
            End If
        End If
    End Sub

    Private Sub StartOnServerToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StartOnServerToolStripMenuItem.Click

        'Try
        '    If Not cSockets.isClientConnected Then cSockets.ConnectToServer()
        'Catch ex As Exception
        '    MsgBox(String.Format("Could not connect to Server:{0}{1}", vbCrLf, ex.Message), MsgBoxStyle.Exclamation, "Connection failed")
        '    Return
        'End Try

        'cSockets.SendData(lsv_ChannelList.SelectedItems(0).Text)
        ''cSockets.Serk
        'Shell(cSettings.Cfg.sVlcExe & " http://" & cSettings.Cfg.sServerIP & ":8080", AppWinStyle.NormalFocus)

        If lsv_ChannelList.SelectedItems.Count = 1 Then
            Dim cn As ChannelBase = lsv_ChannelList.SelectedItems(0).Tag

            Dim frm As New dlgRun(cn)
            frm.ShowDialog()


        End If


    End Sub

    Private Sub StopServerToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StopServerToolStripMenuItem.Click
        StopServerToolStripMenuItem.Enabled = False
        cSockets.StopServer()
        StartServerToolStripMenuItem.Enabled = True
    End Sub

    Private Sub StartServerToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StartServerToolStripMenuItem.Click

        ' The server warning may be notifies the user that settings will be overwritten
        If cSettings.CheckServerWarning() Then
            Try
                cSockets.StartServer()
            Catch ex As Exception
                MessageBox.Show("Could not start listening to port " & cSettings.Cfg.iServerPort & _
                                    vbCrLf & vbCrLf & "The reported error was:" & ex.Message, _
                                    "Could not start server", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End Try

            If cSockets.IsServerStarted Then
                StartServerToolStripMenuItem.Enabled = False
                StopServerToolStripMenuItem.Enabled = True
            End If
        Else
            StopServerToolStripMenuItem.Enabled = False
        End If
    End Sub


    Private Sub frm_MainWindow_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed

        ' Nur speichern, wenn der Benutzer bereits Optionen konfiguriert hat
        If cSettings.CfgFileExists Then
            ' Da evntl. eine neue Favoritengruppe gewhlt wurde bzw. eine neue Aufnahmedatei erstellt, 
            ' diese Infos mit allen anderen nderungen zurckspeichern, damit dies beim nchsten mal wieder
            ' vorgeblendet werden kann
            cSettings.SaveCfg()
        End If
    End Sub

    ''' <summary>
    ''' Kommandos zur Ausfhrung des Kanals in VLC
    '''  (Beschreibungen, ...
    ''' </summary>
    ''' <remarks></remarks>
    Sub VLC_Commands()

        ' VLC-Commands und VLC-Descriptions aus der Registry holen
        For i As Integer = 0 To 14
            tsmi_PlayinVLC.DropDownItems(i).Text = My.Computer.Registry.GetValue("HKEY_CURRENT_USER\SOFTWARE\COOL.STF\TSReader", "VLCConfigDescription" & i, "")

            AddHandler tsmi_PlayinVLC.DropDownItems(i).Click, AddressOf VLC_ToolStripMenuItem_Click
        Next i
    End Sub

    Private Sub VLC_ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

        If lsv_ChannelList.SelectedItems.Count > 0 Then
            Dim s As ToolStripItem = sender

            ' Der Index des Kanals (+1) in der Dropdownliste des Toolstrips entspricht der
            ' VLC-Konfigurationsnummer beim Aufruf
            chanMngmnt.LaunchChannelInVLC(lsv_ChannelList.SelectedItems(0).Tag, _
                                            tsmi_PlayinVLC.DropDownItems.IndexOf(s) + 1)
        End If
    End Sub

    ''' <summary>
    ''' Kanle aus der Kanalliste nehmen in den Listview zur Anzeige einfgen
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub DisplayChannels()

        ' Icon fr jeden Kanal in einer Auflsung von 128 x 128 Pixeln, da das Logo bereits
        ' so komprimiert wurde
        Dim chanicons As New ImageList()
        chanicons.ImageSize = New Size(128, 128)
        chanicons.ColorDepth = ColorDepth.Depth32Bit

        lsv_ChannelList.Items.Clear() ' Kanle entfernen, die evtnl. noch durch den letzen Durchgang brig sind

        Dim i As Integer = 0
        For Each c As ChannelBase In chanMngmnt.currChannels

            ' Favoritengruppe 0 == Alle Kanle!
            If c.iFavorite = cSettings.Cfg.lastFavorite Or cSettings.Cfg.lastFavorite = 0 Then
                Dim li As New ListViewItem(c.sName, i)
                li.Tag = c

                chanicons.Images.Add(c.bLogo)

                With lsv_ChannelList.Items.Add(li)
                    .SubItems.Add(c.iFrequency)

                    If cSettings.Cfg.cTvHardware = ChannelType.DVBS Or cSettings.Cfg.cTvHardware = ChannelType.DVBSFull Then
                        Dim cs As ChannelDVBS = c
                        .SubItems.Add(cs.iSymbolRate)
                        .SubItems.Add(cs.iLNBFrequency)
                        .SubItems.Add(cs.bKhz)
                        .SubItems.Add([Enum].GetName(GetType(DvbSPols), cs.polarisation))

                        If cSettings.Cfg.cTvHardware = ChannelType.DVBSFull Then
                            Dim cs2 As ChannelDVBSFull = cs
                            .SubItems.Add([Enum].GetName(GetType(DvbSModes), cs2.dvbsMode))
                            .SubItems.Add(cs2.iFec)
                        End If

                        .SubItems.Add(cs.shSwitch)

                    ElseIf cSettings.Cfg.cTvHardware = ChannelType.DVBC Then
                        Dim cc As ChannelDVBC = c
                        .SubItems.Add(cc.iSymbolRate)
                        .SubItems.Add(cc.iQAM)
                        .SubItems.Add(cc.bInversion)
                        .SubItems.Add(cc.iBandwith)

                    ElseIf cSettings.Cfg.cTvHardware = ChannelType.DVBT Then
                        Dim ct As ChannelDVBT = c
                        .SubItems.Add(ct.bInversion)
                        .SubItems.Add(ct.iBandwith)

                    End If

                    .SubItems.Add(c.iProgNo)
                End With

                i += 1
            End If
        Next

        lsv_ChannelList.LargeImageList = chanicons
    End Sub

    ''' <summary>
    ''' Contextmen-Handling (depending on channel-selection)
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub lsv_ChannelList_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles lsv_ChannelList.MouseUp

        ' Contextmen nur ber einen Rechtsklick anzeigen
        If e.Button = Windows.Forms.MouseButtons.Right Then
            If lsv_ChannelList.SelectedItems.Count > 0 Then
                cmstripChannel.Show(lsv_ChannelList, e.X, e.Y)
            Else
                cmstripNoChannel.Show(lsv_ChannelList, e.X, e.Y)
            End If
        End If
    End Sub

    Private Sub NewChannelToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NewChannelToolStripMenuItem.Click
        tsb_NewChannel_Click(Nothing, Nothing) ' Same action as clicking on the Toolstripmenu-Button
    End Sub

    Private Sub StopChannelOnServerToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StopChannelOnServerToolStripMenuItem.Click
        cSockets.StopChannelOnServer()
    End Sub

    Private Sub GetAdditionalChannelsFromServerToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GetAdditionalChannelsFromServerToolStripMenuItem.Click
        cSockets.GetAllChannelsFromServer() ' Start receiving channels

        ' Show the user that receiving channels is in progress
        ToolStripStatusLbl.Text = "Receiving channels..."
        ToolStripStatusLbl.Visible = True
        ToolStripPrgrBar.Visible = True

        ' In this case the Timer makes sure that the GUI is not accessed from another Thread
        TimerReceiveChannels.Start()

        AddHandler cSockets.OnDataReceived, AddressOf OnReceiveData
    End Sub

    ''' <summary>
    ''' Get's called once the server successfully sent data to this computer
    ''' </summary>
    ''' <param name="text">The text from the server</param>
    ''' <remarks></remarks>
    Private Sub OnReceiveData(ByVal text As String)
        StatusMessage = text

        RemoveHandler cSockets.OnDataReceived, AddressOf OnReceiveData
    End Sub

    Private Sub TimerReceiveChannels_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TimerReceiveChannels.Tick

        ' Wait until a StatusMessage has been received
        If Not String.IsNullOrEmpty(StatusMessage) Then
            TimerReceiveChannels.Stop()

            ToolStripStatusLbl.Text = StatusMessage
            ToolStripPrgrBar.Visible = False

            ' Refresh the channel list
            chanMngmnt = New cChannels(cSettings.Cfg.cTvHardware)
            DisplayChannels()
        End If
    End Sub

    Private Sub cmstripNoChannel_Opening(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cmstripNoChannel.Opening
        If CopiedChannel Is Nothing Then
            PasteToolStripMenuItem.Enabled = False
        Else
            PasteToolStripMenuItem.Enabled = True
        End If
    End Sub

    Private Sub CopyToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CopyToolStripMenuItem.Click
        If lsv_ChannelList.SelectedItems.Count = 1 Then

            ' By Serializing and Deserilizing the channel we get a real copy of the object
            Dim NewChannel As ChannelBase = lsv_ChannelList.SelectedItems(0).Tag
            Dim NewByteChannel As Byte() = cHelper.SerializeToXML(NewChannel)
            CopiedChannel = cHelper.DeserializeFromXML(NewChannel.GetType, NewByteChannel)
        End If
    End Sub

    Private Sub PasteToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PasteToolStripMenuItem.Click

        ' Change the channel name, so the user can see which channel is new
        CopiedChannel.sName = CopiedChannel.sName + " (2)"
        chanMngmnt.AddChannel(CopiedChannel)
        CopiedChannel = Nothing

        ' Refresh the channel list
        chanMngmnt = New cChannels(cSettings.Cfg.cTvHardware)
        DisplayChannels()
    End Sub
End Class