Imports System.io
Imports TsChanManLibrary

Public Class ucDVBsTransponderList

    ''' <summary>
    ''' Sobald das User-Control geladen wird
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub ucDVBsTransponderList_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' Schauen, wo die Satelliten-Ini-Dateien von TSReader(lite) liegen
        Dim l_sSatTransponderDir As String = cSettings.Cfg.sTsReaderExe.Substring(0, _
                        cSettings.Cfg.sTsReaderExe.LastIndexOf("\") + 1) & "Satellites"

        ' Verzeichnis da wo es sein soll?
        If My.Computer.FileSystem.DirectoryExists(l_sSatTransponderDir) Then
            ' Verzeichnis-Info holen
            Dim di As New DirectoryInfo(l_sSatTransponderDir)
            Dim fi As FileInfo() = di.GetFiles() ' DateiInfo fr das Verzeichnis

            ' Fr jede Datei einen Eintrag in den Treeview setzen
            For Each fiitem As FileInfo In fi
                Dim l_sDateiName As String = l_sSatTransponderDir & "\" & fiitem.Name ' Fr den Dateinamen der Ini-Datei

                ' Eintrag in den TreeView machen
                tree_Satellites.Nodes.Add(fiitem.Name.Substring(0, fiitem.Name.IndexOf(".")).Insert(3, ".") & "  " & _
                INIRead(l_sDateiName, "SATTYPE", "2", "-1"))
            Next fiitem

        Else ' Verzeichnis fehlt
            MsgBox("The directory " & l_sSatTransponderDir & " could not be found")
        End If
    End Sub

    ''' <summary>
    ''' Sobald ein anderere Satellit im TreeView ausgewhlt wird
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub tree_Satellites_AfterSelect(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles tree_Satellites.AfterSelect

        ' Alle Nodes im TreeView entfernen
        lsv_Transponders.Items.Clear()

        ' DateiName der Satelliten-Datei
        Dim l_sDateiName As String = cSettings.Cfg.sTsReaderExe.Substring(0, _
                        cSettings.Cfg.sTsReaderExe.LastIndexOf("\") + 1) & "Satellites\" & _
                        tree_Satellites.SelectedNode.Text.Substring(0, 5).Replace(".", "") & ".ini"

        ' Anzahl Transponder auf Satellit holen
        Dim l_iMaxArray As Integer = INIRead(l_sDateiName, "DVB", "0", "-1")
        Dim i As Integer = 1

        ' Alle Transponder durchfetchen
        While i <= l_iMaxArray
            Dim l_sFreqdata() As String
            ' Array mit Transponderdaten
            l_sFreqdata = INIRead(l_sDateiName, "DVB", i, "-1").Split(",")

            ' Frequenzen, Polarisation und Symbolrate mit da rein!
            With lsv_Transponders.Items.Add(l_sFreqdata(0))
                .SubItems.Add(l_sFreqdata(1))
                .SubItems.Add(l_sFreqdata(2))
                .SubItems.Add(l_sFreqdata(3))
            End With

            ' Hochzhlen
            i += 1
        End While

    End Sub

    ''' <summary>
    ''' Wenn ein Doppelklick auf einen Transponder durchgefhrt wird
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub lsv_Transponders_DoubleClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lsv_Transponders.DoubleClick

        ' Neue Instanz der Settings-Klasse erstellen
        'Dim cSettings2 As New clsSettings()

        '' String enthlt die Parameter fr die Kommandozeile
        'Dim strStartParam As String = cSettings.Cfg.sTsReaderExe & " "

        '' Eine Frequenz starten, funktioniert nur im DVB-S-Modus
        'If cSettings.Cfg.cTvHardware = ChannelType.DVBS Then

        '    ' Prfen, ob das TSReader Executable da ist
        '    If My.Computer.FileSystem.FileExists(cSettings.Cfg.sTsReaderExe) Then

        '        ' Zustzliche Start-Parameter
        '        'strStartParam = strStartParam & cSettings2.StartSettings(True)

        '        ' Startparameter fr den TSReader setzen
        '        strStartParam = strStartParam & lsv_Transponders.SelectedItems(0).SubItems(0).Text

        '        ' Die restlichen Parameter setzen
        '        If lsv_Transponders.SelectedItems(0).SubItems(1).Text = "v" Then
        '            strStartParam = strStartParam & " 0 "
        '        Else
        '            strStartParam = strStartParam & " 1 "
        '        End If

        '        ' Symbolrate
        '        strStartParam = strStartParam & lsv_Transponders.SelectedItems(0).SubItems(2).Text

        '        ' Die LNB-Frequency und den 22Khz-Ton je nach Frequenz setzen
        '        If Convert.ToInt32(lsv_Transponders.SelectedItems(0).SubItems(0).Text) > 11800 Then

        '            strStartParam = strStartParam & " 10600 1"
        '        Else
        '            strStartParam = strStartParam & " 9750 0"

        '        End If

        '        ' Fest von Diseqc 1 ausgehen - TODO: Change!
        '        strStartParam = strStartParam & " 1"

        '        ' TSReader starten und Sender einstellen
        '        Shell(strStartParam, AppWinStyle.NormalNoFocus, False)

        '    Else

        '        ' Fehlermeldung ausgeben
        '        MsgBox(cSettings.Cfg.sTsReaderExe & " not found", MsgBoxStyle.Critical, "File not found")
        '    End If
        'Else
        '    ' Fehlermeldung fr DVB-S Full
        '    MsgBox("Tuning into a frequency will only work in normal DVB-S Mode (DVB-S Full not yet supported)")
        'End If
    End Sub
End Class
